'''
this is a part of the heybuddy project
copyright 2010 jezra lickter http://www.jezra.net
'''
import gtk
import gobject

class Settings(gtk.VBox,gobject.GObject):
	__gsignals__={
		'update-account': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						   (gobject.TYPE_STRING,gobject.TYPE_STRING)
			),
		'option-run-as-tray-app': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
					   (gobject.TYPE_BOOLEAN,)
		),
		'option-context-backwards': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
					   (gobject.TYPE_BOOLEAN,)
		),
		'option-no-avatars': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
					   (gobject.TYPE_BOOLEAN,)
		),
	}
	
	def __init__(self):
		gtk.VBox.__init__(self)
		gobject.GObject.__init__(self)
		self.set_homogeneous(False)
		self.set_border_width(5)
		#start with a table
		table = gtk.Table(3,2)
		table.attach(gtk.Label("Name:"),0,1,0,1,gtk.SHRINK,gtk.SHRINK)
		table.attach(gtk.Label("Password:"),0,1,1,2,gtk.SHRINK,gtk.SHRINK)
		self.account_name_entry = gtk.Entry()
		self.account_password_entry = gtk.Entry()
		self.account_password_entry.set_invisible_char("*")
		self.account_password_entry.set_visibility(False)
		#add the entries to the table
		table.attach(self.account_name_entry,1,2,0,1,gtk.SHRINK,gtk.SHRINK)
		table.attach(self.account_password_entry,1,2,1,2,gtk.SHRINK,gtk.SHRINK)
		#make a button to register "submit clicks
		enter_button = gtk.Button("Submit")
		enter_button.connect("clicked", self.submit_clicked)
		#attach the button to the table
		table.attach(enter_button,1,2,2,3,gtk.SHRINK,gtk.SHRINK)
		account_frame = gtk.Frame("Account")
		account_frame.add(table)
		self.pack_start(account_frame,False,False,0)
		#add the options settings
		options_box = gtk.VBox(False)
		self.run_as_tray_app = gtk.CheckButton("Run as tray application")
		self.run_as_tray_app.connect("toggled", self.option_toggled,'option-run-as-tray-app')
		self.context_back_asswards = gtk.CheckButton("Conversation: oldest first")
		self.context_back_asswards.connect("toggled", self.option_toggled,'option-context-backwards')
		self.disable_avatars = gtk.CheckButton("Disable avatar downloading")
		self.disable_avatars.connect("toggled", self.option_toggled,'option-no-avatars')
		options_box.pack_start(self.run_as_tray_app,False,False,0)
		options_box.pack_start(self.context_back_asswards,False,False,0)
		options_box.pack_start(self.disable_avatars,False,False,0)
		options_frame = gtk.Frame("Options")
		options_frame.add(options_box)
		self.pack_start(options_frame,False,False,0)
		
	def set_run_as_tray_app(self,boolean):
		self.run_as_tray_app.set_active(boolean)	
	
	def set_context_backwards(self,boolean):
		self.context_back_asswards.set_active(boolean)
		
	def set_no_avatars(self,boolean):
		self.disable_avatars.set_active(boolean)
		
	def set_name(self,name):
		self.account_name_entry.set_text(name)

	def set_password(self,password):
		self.account_password_entry.set_text(password)

	def submit_clicked(self,widget):
		#get the name and password
		n=self.account_name_entry.get_text()
		p=self.account_password_entry.get_text()
		if n!="" and p!="" :
			self.emit("update-account",n,p)

	def option_toggled(self,widget,signal):
		value = widget.get_active()
		self.emit(signal,value)
